/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB Code Configurator - v2.25.2
        Device            :  PIC16F1619
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/tmr1.h"
#include "mcc_generated_files/click_c.h"
#include "main.h"
#include "font.h"

/*
                         Main application
 */
void main(void) {
    // initialize the device
    SYSTEM_Initialize();
    TMR1_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();
    
    RW_SetLow();
    
    OLED_C_Init();
    OLED_C_Background();
    
    D4_SetHigh();
    
    unsigned char mytext[] = "Hello World!";
    
    OLED_C_print(20,20,mytext);
    
    while(1){
        delay_ms(5000);
    }
}

void delay_ms(int msec){
    TMR1_StartTimer();
    for (int x = 0; x < msec; x++){
        while(!TMR1IF);
        TMR1_Reload();
        TMR1IF = 0;
    }
}

void OLED_C_command(unsigned char reg_index, unsigned char reg_value){
//Select index addr
    CS_SetLow();
    DC_SetLow();
    //SPI1_Write(reg_index);
    SPI_Exchange8bit(reg_index);
    CS_SetHigh();
//Write data to reg
    CS_SetLow();
    DC_SetHigh();
    //SPI1_Write(reg_value);
    SPI_Exchange8bit(reg_value);
    CS_SetHigh();
}

void OLED_C_data(unsigned char data_value){
    CS_SetLow();
    
    DC_SetHigh();
    //SPI1_Write(data_value);
    SPI_Exchange8bit(data_value);
    CS_SetHigh();
}

void OLED_C_Init(){
    RST_SetLow();
    delay_ms(50);
    RST_SetHigh();
    delay_ms(50);
    /*  Soft reset */
    OLED_C_command(SEPS114A_SOFT_RESET,0x00);      
    /* Standby ON/OFF*/
    OLED_C_command(SEPS114A_STANDBY_ON_OFF,0x01);          // Standby on
    delay_ms(25);                                           // Wait for 5ms (1ms Delay Minimum)
    OLED_C_command(SEPS114A_STANDBY_ON_OFF,0x00);          // Standby off
    delay_ms(25);                                           // 1ms Delay Minimum (1ms Delay Minimum)
    /* Display OFF */
    OLED_C_command(SEPS114A_DISPLAY_ON_OFF,0x00);
    /* Set Oscillator operation */
    OLED_C_command(SEPS114A_ANALOG_CONTROL,0x00);          // using external resistor and internal OSC
    /* Set frame rate */
    OLED_C_command(SEPS114A_OSC_ADJUST,0x03);              // frame rate : 95Hz
    /* Set active display area of panel */
    OLED_C_command(SEPS114A_DISPLAY_X1,0x00);
    OLED_C_command(SEPS114A_DISPLAY_X2,0x5F);
    OLED_C_command(SEPS114A_DISPLAY_Y1,0x00);
    OLED_C_command(SEPS114A_DISPLAY_Y2,0x5F);
    /* Select the RGB data format and set the initial state of RGB interface port */
    OLED_C_command(SEPS114A_RGB_IF,0x00);                 // RGB 8bit interface
    /* Set RGB polarity */
    OLED_C_command(SEPS114A_RGB_POL,0x00);
    /* Set display mode control */
    OLED_C_command(SEPS114A_DISPLAY_MODE_CONTROL,0x80);   // SWAP:BGR, Reduce current : Normal, DC[1:0] : Normal
    /* Set MCU Interface */
    OLED_C_command(SEPS114A_CPU_IF,0x00);                 // MPU External interface mode, 8bits
    /* Set Memory Read/Write mode */
    OLED_C_command(SEPS114A_MEMORY_WRITE_READ,0x00);
    /* Set row scan direction */
    OLED_C_command(SEPS114A_ROW_SCAN_DIRECTION,0x00);     // Column : 0 --> Max, Row : 0 --> Max
    /* Set row scan mode */
    OLED_C_command(SEPS114A_ROW_SCAN_MODE,0x00);          // Alternate scan mode
    /* Set column current */
    OLED_C_command(SEPS114A_COLUMN_CURRENT_R,0x6E);
    OLED_C_command(SEPS114A_COLUMN_CURRENT_G,0x4F);
    OLED_C_command(SEPS114A_COLUMN_CURRENT_B,0x77);
    /* Set row overlap */
    OLED_C_command(SEPS114A_ROW_OVERLAP,0x00);            // Band gap only
    /* Set discharge time */
    OLED_C_command(SEPS114A_DISCHARGE_TIME,0x01);         // Discharge time : normal discharge
    /* Set peak pulse delay */
    OLED_C_command(SEPS114A_PEAK_PULSE_DELAY,0x00);
    /* Set peak pulse width */
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_R,0x02);
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_G,0x02);
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_B,0x02);
    /* Set precharge current */
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_R,0x14);
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_G,0x50);
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_B,0x19);
    /* Set row scan on/off  */
    OLED_C_command(SEPS114A_ROW_SCAN_ON_OFF,0x00);        // Normal row scan
    /* Set scan off level */
    OLED_C_command(SEPS114A_SCAN_OFF_LEVEL,0x04);         // VCC_C*0.75
    /* Set memory access point */
    OLED_C_command(SEPS114A_DISPLAYSTART_X,0x00);
    OLED_C_command(SEPS114A_DISPLAYSTART_Y,0x00);
    /* Display ON */
    OLED_C_command(SEPS114A_DISPLAY_ON_OFF,0x01);
}

void DDRAM_access(){
    CS_SetLow();
    DC_SetLow();
    //SPI1_Write(0x08);
    SPI_Exchange8bit(0x08);
    CS_SetHigh();
}

//Set memory area(address) to write a display data
void OLED_C_MemorySize(char X1, char X2, char Y1, char Y2){
    OLED_C_command(SEPS114A_MEM_X1,X1);
    OLED_C_command(SEPS114A_MEM_X2,X2);
    OLED_C_command(SEPS114A_MEM_Y1,Y1);
    OLED_C_command(SEPS114A_MEM_Y2,Y2);
}

//Select color
void OLED_C_Color(char colorMSB, char colorLSB ){
    OLED_C_data(colorMSB);
    OLED_C_data(colorLSB);
}

void OLED_C_Background(){
    unsigned i,j,k;
    
    OLED_C_command(0x1D,0x02);                //Set Memory Read/Write mode
    
    OLED_C_MemorySize(0x00,0x5F,0x00,0x5F);
    DDRAM_access();
    for(j=0;j<9216;j++){
        OLED_C_Color(0x00,0x00);
    }
}

void OLED_C_print_char(unsigned char x_pos, unsigned char y_pos, unsigned char ch){
    unsigned char chr = 0x00;
    unsigned char s = 0x00;
    chr = (ch - 32);
    OLED_C_MemorySize(x_pos,x_pos + 7,y_pos, y_pos + 5);
    DDRAM_access();
    for(int x = 0; x < 6; x++){
        unsigned char c = Font_Right[chr][6 - x];
        for(int y = 0; y < 8; y ++){
            if(((c >> y) & 0x01) == 0x01){
                OLED_C_Color(0xFF,0xFF);
            } else {
                OLED_C_Color(0x00,0x00);
            }
        }
    }
}

void OLED_C_print(unsigned char x_pos, unsigned char y_pos, unsigned char ch[]){
    for(int c = 0; c < length(ch); c++){
        OLED_C_print_char(x_pos, y_pos + (c * 6), ch[c]);
    }
}

int length(const char** array) {
  int count = 0;
  while(array[count]) count++;
  return count;
}

/**
 End of File
 */